#include "StdAfx.h"
#include ".\translist.h"
#include "Trans.h"
#include "Brake.h"

using namespace std;

CTransList::CTransList(void)
{
}

void CTransList::Serialize(CArchive &ar)
{
	POSITION pos;
	CTrans *pTrans;
	int nNum;
	if(ar.IsStoring() == TRUE)
	{
		pos = this->GetHeadPosition();
		ar << (int)this->GetCount();
		while(pos != NULL)
		{
			pTrans = (CTrans*)this->GetNext(pos);
			pTrans->Serialize(ar);
		}
	}
	else
	{
		ar >> nNum;
		for(int i=0; i<nNum; i++)
		{
			CTrans *pTrans;
			pTrans = new CTrans();
			pTrans->Serialize(ar);
			this->AddTail((CObject*)pTrans);
		}
	}
}

void CTransList::DeleteAll(void)
{
	this->RemoveAll();
}

CTrans* CTransList::GetLetter(int nPos)
{
	POSITION pos = this->FindIndex(nPos);
	if(pos == NULL)
		return NULL;
	else
		return (CTrans*)this->GetAt(pos);
}
CTransList* CTransList::GetSylaba(int nPos)
{
	POSITION pos = this->FindIndex(nPos);
	if(pos == NULL)
		return NULL;
	else
		return (CTransList*)this->GetAt(pos);
}

void CTransList::InsertAt(int nIndex, CTrans *pTrans)
{
	POSITION posBef = this->FindIndex(nIndex+1);
	POSITION pos = this->FindIndex(nIndex);
	if(posBef != NULL)
	{
		this->RemoveAt(pos);
		this->InsertBefore(posBef, (CObject*)pTrans);
	}
	else
	{
		this->RemoveTail();
		this->AddTail((CObject*)pTrans);
	}
}
void CTransList::InsertAt(int nIndex, CTransList* pTransList)
{
	POSITION posBef = this->FindIndex(nIndex+1);
	POSITION pos = this->FindIndex(nIndex);
	if(posBef != NULL)
	{
		this->RemoveAt(pos);
		this->InsertBefore(posBef, (CObject*)pTransList);
	}
	else
	{
		this->RemoveTail();
		this->AddTail((CObject*)pTransList);
	}
}
void CTransList::InsertAft(int nIndex, CTrans *pTrans)
{
	POSITION pos = this->FindIndex(nIndex);
	if(pos != NULL)
	{
		this->InsertAfter(pos, (CObject*)pTrans);
	}
}
void CTransList::InsertAft(int nIndex, CTransList* pTransList)
{
	POSITION pos = this->FindIndex(nIndex);
	if(pos != NULL)
	{
		this->InsertAfter(pos, (CObject*)pTransList);
	}
}

void CTransList::Display(void)
{
	CTrans *pTrans;
	CBrake *pBrake;
	POSITION pos = this->GetHeadPosition();	
	while(pos != NULL)
	{
		pTrans = (CTrans*)this->GetNext(pos);
		switch(pTrans->GetLetter()[0])
		{
		case char(32):
			pBrake = (CBrake*)pTrans;
			//cout << pBrake->GetLetter() << endl;
			cout << "_ 50" << endl;
			cout << "_ 50" << endl;
			break;
		case '_':
			pBrake = (CBrake*)pTrans;
			cout << pBrake->GetLetter() << " 50"<< endl;
			cout << "_ 50" << endl;			
			break;	
		default:
			cout << pTrans->GetLetter() << " " << pTrans->GetDuration() << " ";
			cout << "0 " << pTrans->GetFreq() << endl;
			break;
		};		
	}
}

void CTransList::Write(void)
{
	CTrans *pTrans;
	CBrake *pBrake;
	ofstream fout;
	fout.open("synteza.pho", ios::app);
	for(int i=0; i<this->GetCount(); i++)
	{
		pTrans = (CTrans*)this->GetLetter(i);
		switch(pTrans->GetLetter()[0])
		{
		case char(32):
			pBrake = (CBrake*)pTrans;
			//fout << pBrake->GetLetter() << "\n";
			fout << "_ 50" << "\n";
			fout << "_ 50" << "\n";
			break;
		case '_':
			pBrake = (CBrake*)pTrans;
			fout << pBrake->GetLetter() << " 50"<< "\n";
			fout << "_ 50" << "\n";
			break;	
		default:
			fout << pTrans->GetLetter() << " " << pTrans->GetDuration() << " ";
			fout << "0 " << pTrans->GetFreq() << "\n";
			break;
		};		
	}
	fout.flush();
	fout.close();
}

void CTransList::Remove(int nIndex)
{
	POSITION pos;
	pos = this->FindIndex(nIndex);
	if(pos != NULL)
	{
		this->RemoveAt(pos);
	}
}